import { Directive, Input, TemplateRef } from '@angular/core';
export class QueryInputDirective {
    constructor(template) {
        this.template = template;
    }
    /** Unique name for query input type. */
    get queryInputType() { return this._type; }
    set queryInputType(value) {
        // If the directive is set without a type (updated programatically), then this setter will
        // trigger with an empty string and should not overwrite the programatically set value.
        if (!value) {
            return;
        }
        this._type = value;
    }
}
QueryInputDirective.decorators = [
    { type: Directive, args: [{ selector: '[queryInput]' },] },
];
/** @nocollapse */
QueryInputDirective.ctorParameters = () => [
    { type: TemplateRef, },
];
QueryInputDirective.propDecorators = {
    'queryInputType': [{ type: Input },],
};
//# sourceMappingURL=query-input.directive.js.map